// findinterface.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>
#include <initguid.h>
#include <setupapi.h>
#include <stdio.h>
#include <conio.h>

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Interface Class GUIDs
DEFINE_GUID(GUID_DEVINTERFACE_DISK,                   0x53f56307L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_CDROM,                  0x53f56308L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_PARTITION,              0x53f5630aL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_TAPE,                   0x53f5630bL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_WRITEONCEDISK,          0x53f5630cL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_VOLUME,                 0x53f5630dL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_MEDIUMCHANGER,          0x53f56310L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_FLOPPY,                 0x53f56311L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_CDCHANGER,              0x53f56312L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_STORAGEPORT,            0x2accfe60L, 0xc130, 0x11d2, 0xb0, 0x82, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
DEFINE_GUID(GUID_DEVINTERFACE_COMPORT,                0x86e0d1e0L, 0x8089, 0x11d0, 0x9c, 0xe4, 0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73);
DEFINE_GUID(GUID_DEVINTERFACE_SERENUM_BUS_ENUMERATOR, 0x4D36E978L, 0xE325, 0x11CE, 0xBF, 0xC1, 0x08, 0x00, 0x2B, 0xE1, 0x03, 0x18);
//

struct _GUID * GlobalGuid[20]={ 
	(struct _GUID *)&GUID_DEVINTERFACE_DISK, 
	(struct _GUID *)&GUID_DEVINTERFACE_CDROM,
	(struct _GUID *)&GUID_DEVINTERFACE_PARTITION,
	(struct _GUID *)&GUID_DEVINTERFACE_TAPE,
	(struct _GUID *)&GUID_DEVINTERFACE_WRITEONCEDISK, 
	(struct _GUID *)&GUID_DEVINTERFACE_VOLUME,
	(struct _GUID *)&GUID_DEVINTERFACE_MEDIUMCHANGER,
	(struct _GUID *)&GUID_DEVINTERFACE_FLOPPY,
	(struct _GUID *)&GUID_DEVINTERFACE_CDCHANGER,
	(struct _GUID *)&GUID_DEVINTERFACE_STORAGEPORT,
	(struct _GUID *)&GUID_DEVINTERFACE_COMPORT,
	(struct _GUID *)&GUID_DEVINTERFACE_SERENUM_BUS_ENUMERATOR,
	0
	};

char * GlobalString[20]={
	"GUID_DEVINTERFACE_DISK	 ġ",
	"GUID_DEVINTERFACE_CDROM  ġ",
	"GUID_DEVINTERFACE_PARTITION  ġ",
	"GUID_DEVINTERFACE_TAPE  ġ",
	"GUID_DEVINTERFACE_WRITEONCEDISK  ġ",
	"GUID_DEVINTERFACE_VOLUME  ġ",
	"GUID_DEVINTERFACE_MEDIUMCHANGER  ġ",
	"GUID_DEVINTERFACE_FLOPPY  ġ",
	"GUID_DEVINTERFACE_CDCHANGER  ġ",
	"GUID_DEVINTERFACE_STORAGEPORT  ġ",
	"GUID_DEVINTERFACE_COMPORT  ġ",
	"GUID_DEVINTERFACE_SERENUM_BUS_ENUMERATOR  ġ",
	0
	};

//  Ǵ GUID ϴ DeviceStack  ˷ݴϴ
int GetDeviceStackNameCount( struct _GUID * pGuid )
{
	SP_INTERFACE_DEVICE_DATA interfaceData;
	int index=0;
	HDEVINFO Info;

	Info = SetupDiGetClassDevs( pGuid, 0, 0, DIGCF_PRESENT|DIGCF_INTERFACEDEVICE );

	if( Info == (HDEVINFO) -1 )
		return 0; // ý ̷   Ѵ

	interfaceData.cbSize = sizeof(SP_INTERFACE_DEVICE_DATA);
	
	while( 1 )
	{
		BOOLEAN bl;
		bl = SetupDiEnumDeviceInterfaces( Info, 0, (struct _GUID *)pGuid, index, &interfaceData );
		if( bl == FALSE )
			break;
		index++;
	}

	SetupDiDestroyDeviceInfoList( Info );

	return index;
}

//  Ǵ GUID ϴ DeviceStack ̸ ˷ݴϴ
BOOLEAN GetDeviceStackName( struct _GUID * pGuid, char ** ppDeviceName, int index )
{
	DWORD size;
	BOOLEAN bl;
	SP_INTERFACE_DEVICE_DATA interfaceData;
	PSP_INTERFACE_DEVICE_DETAIL_DATA pData;
	HDEVINFO Info;
	char *pDeviceName;

	Info = SetupDiGetClassDevs( pGuid, 0, 0, DIGCF_PRESENT|DIGCF_INTERFACEDEVICE );

	*ppDeviceName = (char *)0;

	if( Info == (HANDLE) -1 )
		return FALSE;

	interfaceData.cbSize = sizeof(SP_INTERFACE_DEVICE_DATA);
	
	bl = SetupDiEnumDeviceInterfaces( Info, 0, (struct _GUID *)pGuid, index, &interfaceData );
	if( bl == FALSE )
		return bl;

	SetupDiGetDeviceInterfaceDetail( Info, &interfaceData, 0, 0, &size, 0 );
	pData = (PSP_INTERFACE_DEVICE_DETAIL_DATA)malloc( size );
	pData->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
	SetupDiGetDeviceInterfaceDetail( Info, &interfaceData, pData, size, 0, 0 );

	pDeviceName = (char *)malloc( strlen(pData->DevicePath) + 1 );
	memset( pDeviceName, 0, strlen(pData->DevicePath) );
	strcpy( pDeviceName, pData->DevicePath );
	free( pData );

	SetupDiDestroyDeviceInfoList( Info );
	*ppDeviceName = pDeviceName;
	return TRUE;
}

//
//***********************************************************


int main(int argc, char* argv[])
{
	HANDLE deviceHandle;
	int count;
	char *pDeviceName;
	BOOLEAN bl;
	int i;
	struct _GUID * pGuid;
	int GuidCount=0;

	while(1)
	{
		if( GlobalGuid[GuidCount] == 0 )
			break;

		pGuid = GlobalGuid[GuidCount];

		printf("=======================================\n");
		printf("%s  ãϴ\n", GlobalString[GuidCount]);

		GuidCount++;

		count = GetDeviceStackNameCount( pGuid );
		if( count )
		{
			printf("ġ شϴ Interface ̽(s) %d ãҽϴ\n", count);
			printf("---------------------------------------------------------\n");
		}
		else
		{
			printf("ġ شϴ Interface ̽(s) ã ߽ϴ\n");
		}

		for( i = 0 ; i < count ; i ++ )
		{
			bl = GetDeviceStackName( pGuid, &pDeviceName, i ); // 翬 1̻ ġ ġǾǷ..0 Ѵ

			printf("̽ ̸ %s Դϴ\n", pDeviceName );

			deviceHandle = CreateFile( pDeviceName, FILE_SHARE_READ|FILE_SHARE_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL );
			if( deviceHandle == (HANDLE)-1 )
			{
				printf("̽  ߽ϴ\n");
			}
			else
			{
				printf("̽  ϴ\n");
				CloseHandle( deviceHandle );
			}
			free( pDeviceName );
			printf("---------------------------------------------------------\n");
		}
	}
	getch();
	return 0;
}
