/*
Function Driver ޵Ǵ System Power State ̹ ϴ Device Power State ȯŰ
    ִ
*/
#include "ntddk.h"
#include "SAMPLE.h"
#include "power.h"

extern NTSTATUS PowerChangeNotificationRoutine( PDEVICE_OBJECT DeviceObject, DEVICE_POWER_STATE OldState, DEVICE_POWER_STATE NewState );
extern void IrpStringOut( PIRP Irp );

///////////////////////////////////////////////////////////////////////////
NTSTATUS DoJob( PDEVICE_OBJECT DeviceObject, DEVICE_POWER_STATE NewState )
{
	// ý Ŀå ٲ Ȳ ߻Ҷ ̹ PowerChangeNotificationRoutine()Լ ȣϵ Ѵ
	PDEVICE_EXTENSION		deviceExtension;

	deviceExtension = DeviceObject->DeviceExtension;

	return PowerChangeNotificationRoutine( DeviceObject, deviceExtension->DevicePowerState, NewState );
}
///////////////////////////////////////////////////////////////////////////

VOID
CompletionNotificationDevicePowerIrp(
    IN  PDEVICE_OBJECT              DeviceObject,
    IN  UCHAR                       MinorFunction,
    IN  POWER_STATE                 PowerState,
    IN  POWER_COMPLETION_CONTEXT*   Context,
    IN  PIO_STATUS_BLOCK            IoStatus
    )
{
	PDEVICE_EXTENSION		deviceExtension;
	NTSTATUS status;
	PPOWER_COMPLETION_CONTEXT pContext=NULL;
	PIRP					Irp;

	pContext = (PPOWER_COMPLETION_CONTEXT)Context;
	
	Irp = pContext->Irp;
	DeviceObject = pContext->DeviceObject;
	
	Irp->IoStatus.Status = IoStatus->Status;
	
	PoStartNextPowerIrp( Irp );
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	
	ExFreePool( pContext );
	return;
}

NTSTATUS CompletionRoutineSystemPowerIrp( PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context )
{
	PDEVICE_EXTENSION		deviceExtension;
	PIO_STACK_LOCATION IrpStack;
	NTSTATUS status;
	PPOWER_COMPLETION_CONTEXT pContext=NULL;
	POWER_STATE State;

	deviceExtension = DeviceObject->DeviceExtension;

	IrpStack = IoGetCurrentIrpStackLocation( Irp );

	if( Irp->PendingReturned )
		IoMarkIrpPending( Irp );
	
	if( !NT_SUCCESS( Irp->IoStatus.Status ) )
	{
		PoStartNextPowerIrp( Irp );
		return Irp->IoStatus.Status;
	}

	deviceExtension->SystemPowerState = IrpStack->Parameters.Power.State.SystemState;

	pContext	 = (PPOWER_COMPLETION_CONTEXT)ExAllocatePool( NonPagedPool, sizeof(POWER_COMPLETION_CONTEXT) );
	if( !pContext )
	{
		PoStartNextPowerIrp( Irp );
		status = STATUS_UNSUCCESSFUL;
		Irp->IoStatus.Status = status;
		return status;
	}

	pContext->DeviceObject = DeviceObject;
	pContext->Irp = Irp;
		
	State.DeviceState = deviceExtension->DeviceCaps.DeviceState[deviceExtension->SystemPowerState];
	
	PoRequestPowerIrp(
	    deviceExtension->PhysicalDeviceObject,
	    IrpStack->MinorFunction,
	    State,
	    CompletionNotificationDevicePowerIrp,
	    pContext,
	    NULL
	    );

	return STATUS_MORE_PROCESSING_REQUIRED;
}

NTSTATUS CompletionRoutineDevicePowerIrp( PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context )
{
	PDEVICE_EXTENSION		deviceExtension;
	PIO_STACK_LOCATION IrpStack;
	NTSTATUS status;

	deviceExtension = DeviceObject->DeviceExtension;

	IrpStack = IoGetCurrentIrpStackLocation( Irp );

	if( Irp->PendingReturned )
		IoMarkIrpPending( Irp );
	
	if( !NT_SUCCESS( Irp->IoStatus.Status ) )
	{
		PoStartNextPowerIrp( Irp );
		return Irp->IoStatus.Status;
	}

	PoSetPowerState(DeviceObject, DevicePowerState, IrpStack->Parameters.Power.State );

	if( deviceExtension->DevicePowerState > IrpStack->Parameters.Power.State.DeviceState ) // Low -> High
	{
		DoJob( DeviceObject, IrpStack->Parameters.Power.State.DeviceState );
		deviceExtension->DevicePowerState = IrpStack->Parameters.Power.State.DeviceState;
	}
	else	 //High->Low
		deviceExtension->DevicePowerState = IrpStack->Parameters.Power.State.DeviceState;

	PoStartNextPowerIrp( Irp );

	return Irp->IoStatus.Status;
}

NTSTATUS                                                            
DispatchSystemPowerIrp
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{
	PDEVICE_EXTENSION		deviceExtension;
	NTSTATUS status;
	
	deviceExtension = DeviceObject->DeviceExtension;

	IoCopyCurrentIrpStackLocationToNext( Irp );
	IoSetCompletionRoutine( 
		Irp, 
		CompletionRoutineSystemPowerIrp,
		NULL,
		TRUE,
		TRUE,
		TRUE 
		);
	return PoCallDriver( deviceExtension->NextLayerDeviceObject, Irp );
}

NTSTATUS                                                            
DispatchDevicePowerIrp
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{
	PDEVICE_EXTENSION		deviceExtension;
	PIO_STACK_LOCATION IrpStack;
	NTSTATUS status;
	POWER_STATE         state;
	PPOWER_COMPLETION_CONTEXT pContext=NULL;
	
	deviceExtension = DeviceObject->DeviceExtension;

	IrpStack = IoGetCurrentIrpStackLocation( Irp );
	state.DeviceState = IrpStack->Parameters.Power.State.DeviceState;
	
	if( deviceExtension->DevicePowerState == state.DeviceState )
	{
		PoStartNextPowerIrp( Irp );
		IoSkipCurrentIrpStackLocation( Irp );
		return PoCallDriver( deviceExtension->NextLayerDeviceObject, Irp );
	}
	
	if( deviceExtension->DevicePowerState > state.DeviceState ) // Low -> High
	{
		IoCopyCurrentIrpStackLocationToNext( Irp );
		IoSetCompletionRoutine( 
			Irp, 
			CompletionRoutineDevicePowerIrp,
			NULL,
			TRUE,
			TRUE,
			TRUE 
			);
		return PoCallDriver( deviceExtension->NextLayerDeviceObject, Irp );
	}
	else // High -> Low
	{
		DoJob( DeviceObject, IrpStack->Parameters.Power.State.DeviceState );
		IoCopyCurrentIrpStackLocationToNext( Irp );
		IoSetCompletionRoutine( 
			Irp, 
			CompletionRoutineDevicePowerIrp,
			NULL,
			TRUE,
			TRUE,
			TRUE 
			);
		return PoCallDriver( deviceExtension->NextLayerDeviceObject, Irp );
	}
}

NTSTATUS                                                            
SAMPLE_PowerDispatch
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{
	PDEVICE_EXTENSION		deviceExtension;
	PIO_STACK_LOCATION IrpStack;
	NTSTATUS status;
	
	DbgPrint("SAMPLE_PowerDispatch ++ \n" );

	IrpStringOut( Irp );

	deviceExtension = DeviceObject->DeviceExtension;

	IrpStack = IoGetCurrentIrpStackLocation( Irp );

	switch(IrpStack->MinorFunction) 
	{
		case IRP_MN_SET_POWER:
			status = (IrpStack->Parameters.Power.Type == SystemPowerState) ?  
				DispatchSystemPowerIrp(DeviceObject, Irp) : DispatchDevicePowerIrp(DeviceObject, Irp);
			break;

		case IRP_MN_QUERY_POWER:
		case IRP_MN_WAIT_WAKE:
		case IRP_MN_POWER_SEQUENCE:
		default:
			PoStartNextPowerIrp( Irp );
			IoSkipCurrentIrpStackLocation( Irp );
			status = PoCallDriver(deviceExtension->NextLayerDeviceObject, Irp);
			break;
	}

	DbgPrint("SAMPLE_PowerDispatch -- \n" );

	return status;
} 
