#include <ntddk.h>

#include "ntddser.h"
#include "Queue.h"

#ifndef _VSERIAL_H_
#define _VSERIAL_H_

#define DRIVER_REGPATH	L"\\REGISTRY\\MACHINE\\HARDWARE\\DEVICEMAP\\SERIALCOMM"

#define IOCTL_REMOVE_NOTIFICATION 			CTL_CODE( FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define MAXPENDINGIRP 10

typedef struct _DEVICE_EXTENSION 
{
	WCHAR DOS_NAME[255];
	WCHAR DOS_NAME2[255];
	SERIAL_TIMEOUTS stimeout;
	PDEVICE_OBJECT DeviceObject;
	KEVENT EmulationPollingExitEvent;
	KEVENT EmulationPollingAnswerEvent;
	KEVENT ReadPollingExitEvent;
	KEVENT ReadPollingAnswerEvent;
	PIRP RemoveNotificaionIrp;
	PIRP PendingRead;
	ULONG dwBaudRate;
	ULONG MODEMSTATUSREGISTER, MODEMCONTROLREGISTER;
	unsigned short RTSDTR;
	ULONG WaitQTail, WaitQHead;
	PDEVICE_OBJECT StackDeviceObject;   /* device object we call when submitting Urbs */
	PIRP PendingWaitIrp[MAXPENDINGIRP];
	ULONG Wm;							
	PDEVICE_OBJECT PhysicalDeviceObject; /* physical device object */
	DEVICE_CAPABILITIES DeviceCapabilities;
	SERIAL_LINE_CONTROL slc;
	KSPIN_LOCK		SpinLock;
	PHAJE_QUEUE	pHajeQueue;	
	UNICODE_STRING	UnicodeString;
}
DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS                                                            
DriverEntry                                                         
	(                                                               
	IN PDRIVER_OBJECT DriverObject,             
	IN PUNICODE_STRING RegistryPath            
	);
NTSTATUS
VSERIAL_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	);
VOID                                                                
VSERIAL_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);
NTSTATUS
VSERIAL_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	);

void SetRegValue( PWCHAR pEntryKey, PUNICODE_STRING pRegKey, PWCHAR pKeyValue, ULONG dwSize );
void WaitIrpCancelRoutine( PDEVICE_OBJECT DeviceObject, PIRP Irp );
	
NTSTATUS
VSERIAL_Power
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
VSERIAL_Dispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);
NTSTATUS                                                            
VSERIAL_Create
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
void pReadPollingFunction(
		IN PVOID context
	);
NTSTATUS                                                            
VSERIAL_Cleanup                                                        
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
NTSTATUS                                                            
VSERIAL_Close                                                        
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
NTSTATUS                                                            
VSERIAL_Read
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
NTSTATUS                                                            
VSERIAL_Write
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
NTSTATUS                                                            
VSERIAL_DeviceIoControl
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);
PIRP OutputPendingWaitIrp( PDEVICE_EXTENSION deviceExtension );
void InputPendingWaitIrp( PDEVICE_EXTENSION deviceExtension, PIRP Irp );
ULONG SizeofPendingWaitIrp(PDEVICE_EXTENSION deviceExtension );

#endif //_VSERIAL_H_
