#include "stdafx.h"
#include <windows.h>

#include <initguid.h>
#include <setupapi.h>
#include <stdio.h>

DEFINE_GUID(SampleGuid, 0x5665dec0, 0xa40a, 0x11d1, 0xb9, 0x84, 0x0, 0x20, 0xaf, 0xd7, 0x97, 0x78);

#define MAXDEVICENUMBER 10

int GetDeviceStackNameCount( struct _GUID * pGuid )
{
	SP_INTERFACE_DEVICE_DATA interfaceData;
	int index=0;
	HDEVINFO Info = SetupDiGetClassDevs( pGuid, 0, 0, DIGCF_PRESENT|DIGCF_INTERFACEDEVICE );

	if( Info == (HDEVINFO) -1 )
		return 0; 

	interfaceData.cbSize = sizeof(SP_INTERFACE_DEVICE_DATA);
	
	while( 1 )
	{
		BOOLEAN bl;
		bl = SetupDiEnumDeviceInterfaces( Info, 0, pGuid, index, &interfaceData );
		if( bl == FALSE )
			break;
		index++;
	}

	SetupDiDestroyDeviceInfoList( Info );

	return index;
}

BOOLEAN GetDeviceStackName( struct _GUID * pGuid, char ** ppDeviceName, int index )
{
	DWORD size;
	BOOLEAN bl;
	SP_INTERFACE_DEVICE_DATA interfaceData;
	PSP_INTERFACE_DEVICE_DETAIL_DATA pData;
	HDEVINFO Info = SetupDiGetClassDevs( pGuid, 0, 0, DIGCF_PRESENT|DIGCF_INTERFACEDEVICE );
	char *pDeviceName;
	*ppDeviceName = (char *)0;

	if( Info == (HANDLE) -1 )
		return FALSE;

	interfaceData.cbSize = sizeof(SP_INTERFACE_DEVICE_DATA);
	
	bl = SetupDiEnumDeviceInterfaces( Info, 0, pGuid, index, &interfaceData );
	if( bl == FALSE )
		return bl;

	SetupDiGetDeviceInterfaceDetail( Info, &interfaceData, 0, 0, &size, 0 );
	pData = (PSP_INTERFACE_DEVICE_DETAIL_DATA)malloc( size );
	pData->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
	SetupDiGetDeviceInterfaceDetail( Info, &interfaceData, pData, size, 0, 0 );

	pDeviceName = (char *)malloc( strlen(pData->DevicePath) + 1 );
	memset( pDeviceName, 0, strlen(pData->DevicePath) );
	strcpy( pDeviceName, pData->DevicePath );
	free( pData );

	SetupDiDestroyDeviceInfoList( Info );
	*ppDeviceName = pDeviceName;
	return TRUE;
}

#include <conio.h>

typedef struct
{
	unsigned char * pPhysicalAddress;
	unsigned long dwMemorySize;
}WRITE_PARAMETER, *PWRITE_PARAMETER;

int main(int argc, char* argv[])
{
	HANDLE handle;
	int count;
	char *pDeviceName;
	BOOLEAN bl;
	ULONG ret;

	count = GetDeviceStackNameCount( (struct _GUID *)&SampleGuid );
	if( count == 0 )
		return 0;

	bl = GetDeviceStackName( (struct _GUID *)&SampleGuid, &pDeviceName, 0 );

	if( bl == FALSE )
		return 0; 

	// for MEMORY
	{
		char FullDeviceName[100];
		strcpy( FullDeviceName, pDeviceName );
		strcat( FullDeviceName, "\\MEMORY" );
		handle = CreateFile( FullDeviceName, GENERIC_READ|GENERIC_WRITE
						   , 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL
						   , 0 );
	}
	if( handle == (HANDLE)-1 )
	{
		free( pDeviceName );
		return 0;
	}
	
	WRITE_PARAMETER WriteParameter;

	WriteParameter.pPhysicalAddress = (unsigned char *)0xD0000000;
	WriteParameter.dwMemorySize = 0x100000;

	WriteFile( handle, &WriteParameter, sizeof( WRITE_PARAMETER ), &ret, NULL );

	unsigned char *pVideoAreaVirtualAddress;

	ReadFile( handle, &pVideoAreaVirtualAddress, sizeof(unsigned char *), &ret, NULL );

	//  ּҸ غϴ
	// ȭ鿡  ̻  ĥغô
	for( int pos = 0 ; pos < 0x100000 ; pos ++  )
	{
		*(pVideoAreaVirtualAddress+pos) = pos % 0x100;
	}

	getch();

	CloseHandle( handle );
	// ּҴ ڵ ų, ٸ ּҰ Ӱ εǸ ڵ ȴ

	free( pDeviceName );
	return 0;
}
