#include <ntddk.H>

#ifndef _SAMPLE_
#define _SAMPLE_

typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT PhysicalDeviceObject; /* physical device object */
	PDEVICE_OBJECT NextLayerDeviceObject; /* Next Layer device object */
	PDEVICE_OBJECT DeviceObject; /* Self device object */
	UNICODE_STRING UnicodeString; 
	// ڿ  DeviceStack  ̸ ϴ°

	KDPC MyDpc;
	KTIMER MyTimer;
}DEVICE_EXTENSION, *PDEVICE_EXTENSION;

void
STARTIO_StartIo
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

VOID
MyDpcRoutine(
    IN PKDPC Dpc,
    IN PVOID DeferredContext,
    IN PVOID SystemArgument1,
    IN PVOID SystemArgument2
    );

NTSTATUS
STARTIO_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	);

VOID                                                                
STARTIO_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);

NTSTATUS
STARTIO_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	);

NTSTATUS
STARTIO_Create
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS                                                            
STARTIO_Cleanup
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);

NTSTATUS
STARTIO_Close
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
STARTIO_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
STARTIO_PowerDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
STARTIO_DeviceIoControl
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

void 
_SpeakerOn( unsigned short Frequency );

void 
_SpeakerOff();

#endif //_SAMPLE_
